//Define the SPI Pin Numbers since we’re not using SPI
#define DATAOUT 11//MOSI
#define DATAIN  12//MISO
#define SPICLOCK  13//sck
#define SLAVESELECT 10//ss

void setup() {
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR1); //SPI Bus setup

  //Set all the pins 
  pinMode(DATAOUT, OUTPUT);
  pinMode(DATAIN, INPUT);
  pinMode(SPICLOCK,OUTPUT);
  pinMode(SLAVESELECT,OUTPUT);

  //Make sure the RGB matrix is deactivated
  digitalWrite(SLAVESELECT,HIGH); 

}

void loop() {

 //Activate the RGB Matrix
  digitalWrite(SLAVESELECT, LOW);
  //Send the color buffer to the RGB Matrix
  for(int LED=0; LED<64; LED++){
    spi_transfer(color_buffer[LED]);
  }

  //Deactivate the RGB matrix.
  digitalWrite(SLAVESELECT, HIGH);
  delay(5); // allow some time for the Serial data to be sent 

} 

//This replaces SPI.transfer
char spi_transfer(volatile char data)
{
  SPDR = data;                    // Start the transmission
  while (!(SPSR & (1<<SPIF))){}  // Wait for the end of the transmission
  return SPDR;                    // return the received byte
}
